## etcd 3.3.25+dfsg

=== Makefile ===
# run from repository root



# Example:
#   make build
#   make clean
#   make docker-clean
#   make docker-start
#   make docker-kill
#   make docker-remove

.PHONY: build
build:
	GO_BUILD_FLAGS="-v" ./build
	./bin/etcd --version
	ETCDCTL_API=3 ./bin/etcdctl version

clean:
	rm -f ./codecov
	rm -rf ./agent-*
	rm -rf ./covdir
	rm -f ./*.coverprofile
	rm -f ./*.log
	rm -f ./bin/Dockerfile-release
	rm -rf ./bin/*.etcd
	rm -rf ./default.etcd
	rm -rf ./tests/e2e/default.etcd
	rm -rf ./gopath
	rm -rf ./gopath.proto
	rm -rf ./release
	rm -f ./snapshot/localhost:*
	rm -f ./integration/127.0.0.1:* ./integration/localhost:*
	rm -f ./clientv3/integration/127.0.0.1:* ./clientv3/integration/localhost:*
	rm -f ./clientv3/ordering/127.0.0.1:* ./clientv3/ordering/localhost:*

docker-clean:
	docker images
	docker image prune --force

docker-start:
	service docker restart

docker-kill:
	docker kill `docker ps -q` || true

docker-remove:
	docker rm --force `docker ps -a -q` || true
	docker rmi --force `docker images -q` || true



GO_VERSION ?= 1.12.9
ETCD_VERSION ?= $(shell git rev-parse --short HEAD || echo "GitNotFound")

TEST_SUFFIX = $(shell date +%s | base64 | head -c 15)
TEST_OPTS ?= PASSES='unit'

TMP_DIR_MOUNT_FLAG = --mount type=tmpfs,destination=/tmp
ifdef HOST_TMP_DIR
	TMP_DIR_MOUNT_FLAG = --mount type=bind,source=$(HOST_TMP_DIR),destination=/tmp
endif



# Example:
#   GO_VERSION=1.12.9 make build-docker-test
#   make build-docker-test
#
#   gcloud docker -- login -u _json_key -p "$(cat /etc/gcp-key-etcd-development.json)" https://gcr.io
#   GO_VERSION=1.12.9 make push-docker-test
#   make push-docker-test
#
#   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com
#   make pull-docker-test

build-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	@sed -i.bak 's|REPLACE_ME_GO_VERSION|$(GO_VERSION)|g' ./tests/Dockerfile
	docker build \
	  --tag gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3 \
	  --file ./tests/Dockerfile .
	@mv ./tests/Dockerfile.bak ./tests/Dockerfile

push-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	gcloud docker -- push gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3

pull-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker pull gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3



# Example:
#   make build-docker-test
#   make compile-with-docker-test
#   make compile-setup-gopath-with-docker-test

compile-with-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker run \
	  --rm \
	  --mount type=bind,source=`pwd`,destination=/go/src/github.com/coreos/etcd \
	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3 \
	  /bin/bash -c "GO_BUILD_FLAGS=-v GOOS=linux GOARCH=amd64 ./build && ./bin/etcd --version"

compile-setup-gopath-with-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker run \
	  --rm \
	  --mount type=bind,source=`pwd`,destination=/etcd \
	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3 \
	  /bin/bash -c "cd /etcd && ETCD_SETUP_GOPATH=1 GO_BUILD_FLAGS=-v GOOS=linux GOARCH=amd64 ./build && ./bin/etcd --version && rm -rf ./gopath"



# Example:
#
# Local machine:
#   TEST_OPTS="PASSES='fmt'" make test
#   TEST_OPTS="PASSES='fmt bom dep build unit'" make test
#   TEST_OPTS="PASSES='build unit release integration_e2e functional'" make test
#   TEST_OPTS="PASSES='build grpcproxy'" make test
#
# Example (test with docker):
#   make pull-docker-test
#   TEST_OPTS="PASSES='fmt'" make docker-test
#   TEST_OPTS="VERBOSE=2 PASSES='unit'" make docker-test
#
# Travis CI (test with docker):
#   TEST_OPTS="PASSES='fmt bom dep build unit'" make docker-test
#
# Semaphore CI (test with docker):
#   TEST_OPTS="PASSES='build unit release integration_e2e functional'" make docker-test
#   HOST_TMP_DIR=/tmp TEST_OPTS="PASSES='build unit release integration_e2e functional'" make docker-test
#   TEST_OPTS="GOARCH=386 PASSES='build unit integration_e2e'" make docker-test
#
# grpc-proxy tests (test with docker):
#   TEST_OPTS="PASSES='build grpcproxy'" make docker-test
#   HOST_TMP_DIR=/tmp TEST_OPTS="PASSES='build grpcproxy'" make docker-test

.PHONY: test
test:
	$(info TEST_OPTS: $(TEST_OPTS))
	$(info log-file: test-$(TEST_SUFFIX).log)
	$(TEST_OPTS) ./test 2>&1 | tee test-$(TEST_SUFFIX).log
	! egrep "(--- FAIL:|DATA RACE|panic: test timed out|appears to have leaked)" -B50 -A10 test-$(TEST_SUFFIX).log

docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	$(info ETCD_VERSION: $(ETCD_VERSION))
	$(info TEST_OPTS: $(TEST_OPTS))
	$(info log-file: test-$(TEST_SUFFIX).log)
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`,destination=/go/src/github.com/coreos/etcd \
	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3 \
	  /bin/bash -c "$(TEST_OPTS) ./test 2>&1 | tee test-$(TEST_SUFFIX).log"
	! egrep "(--- FAIL:|DATA RACE|panic: test timed out|appears to have leaked)" -B50 -A10 test-$(TEST_SUFFIX).log

docker-test-coverage:
	$(info GO_VERSION: $(GO_VERSION))
	$(info ETCD_VERSION: $(ETCD_VERSION))
	$(info log-file: docker-test-coverage-$(TEST_SUFFIX).log)
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`,destination=/go/src/github.com/coreos/etcd \
	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3 \
	  /bin/bash -c "COVERDIR=covdir PASSES='build build_cov cov' ./test 2>&1 | tee docker-test-coverage-$(TEST_SUFFIX).log && /codecov -t 6040de41-c073-4d6f-bbf8-d89256ef31e1"
	! egrep "(--- FAIL:|DATA RACE|panic: test timed out|appears to have leaked)" -B50 -A10 docker-test-coverage-$(TEST_SUFFIX).log



# Example:
#   make compile-with-docker-test
#   ETCD_VERSION=v3-test make build-docker-release-master
#   ETCD_VERSION=v3-test make push-docker-release-master
#   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com

build-docker-release-master:
	$(info ETCD_VERSION: $(ETCD_VERSION))
	cp ./Dockerfile-release ./bin/Dockerfile-release
	docker build \
	  --tag gcr.io/etcd-development/etcd:$(ETCD_VERSION) \
	  --file ./bin/Dockerfile-release \
	  ./bin
	rm -f ./bin/Dockerfile-release

	docker run \
	  --rm \
	  gcr.io/etcd-development/etcd:$(ETCD_VERSION) \
	  /bin/sh -c "/usr/local/bin/etcd --version && ETCDCTL_API=3 /usr/local/bin/etcdctl version"

push-docker-release-master:
	$(info ETCD_VERSION: $(ETCD_VERSION))
	gcloud docker -- push gcr.io/etcd-development/etcd:$(ETCD_VERSION)



# Example:
#   make build-docker-test
#   make compile-with-docker-test
#   make build-docker-static-ip-test
#
#   gcloud docker -- login -u _json_key -p "$(cat /etc/gcp-key-etcd-development.json)" https://gcr.io
#   make push-docker-static-ip-test
#
#   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com
#   make pull-docker-static-ip-test
#
#   make docker-static-ip-test-certs-run
#   make docker-static-ip-test-certs-metrics-proxy-run

build-docker-static-ip-test:
	$(info GO_VERSION: $(GO_VERSION))
	@sed -i.bak 's|REPLACE_ME_GO_VERSION|$(GO_VERSION)|g' ./tests/docker-static-ip/Dockerfile
	docker build \
	  --tag gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION) \
	  --file ./tests/docker-static-ip/Dockerfile \
	  ./tests/docker-static-ip
	@mv ./tests/docker-static-ip/Dockerfile.bak ./tests/docker-static-ip/Dockerfile

push-docker-static-ip-test:
	$(info GO_VERSION: $(GO_VERSION))
	gcloud docker -- push gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION)

pull-docker-static-ip-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker pull gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION)

docker-static-ip-test-certs-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-static-ip/certs,destination=/certs \
	  gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /certs/run.sh && rm -rf m*.etcd"

docker-static-ip-test-certs-metrics-proxy-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-static-ip/certs-metrics-proxy,destination=/certs-metrics-proxy \
	  gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /certs-metrics-proxy/run.sh && rm -rf m*.etcd"



# Example:
#   make build-docker-test
#   make compile-with-docker-test
#   make build-docker-dns-test
#
#   gcloud docker -- login -u _json_key -p "$(cat /etc/gcp-key-etcd-development.json)" https://gcr.io
#   make push-docker-dns-test
#
#   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com
#   make pull-docker-dns-test
#
#   make docker-dns-test-insecure-run
#   make docker-dns-test-certs-run
#   make docker-dns-test-certs-gateway-run
#   make docker-dns-test-certs-wildcard-run
#   make docker-dns-test-certs-common-name-auth-run
#   make docker-dns-test-certs-common-name-multi-run

build-docker-dns-test:
	$(info GO_VERSION: $(GO_VERSION))
	@sed -i.bak 's|REPLACE_ME_GO_VERSION|$(GO_VERSION)|g' ./tests/docker-dns/Dockerfile
	docker build \
	  --tag gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  --file ./tests/docker-dns/Dockerfile \
	  ./tests/docker-dns
	@mv ./tests/docker-dns/Dockerfile.bak ./tests/docker-dns/Dockerfile

	docker run \
	  --rm \
	  --dns 127.0.0.1 \
	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  /bin/bash -c "/etc/init.d/bind9 start && cat /dev/null >/etc/hosts && dig etcd.local"

push-docker-dns-test:
	$(info GO_VERSION: $(GO_VERSION))
	gcloud docker -- push gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION)

pull-docker-dns-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker pull gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION)

docker-dns-test-insecure-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  --dns 127.0.0.1 \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-dns/insecure,destination=/insecure \
	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /insecure/run.sh && rm -rf m*.etcd"

docker-dns-test-certs-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  --dns 127.0.0.1 \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-dns/certs,destination=/certs \
	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /certs/run.sh && rm -rf m*.etcd"

docker-dns-test-certs-gateway-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  --dns 127.0.0.1 \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-dns/certs-gateway,destination=/certs-gateway \
	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /certs-gateway/run.sh && rm -rf m*.etcd"

docker-dns-test-certs-wildcard-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  --dns 127.0.0.1 \
	  $(TMP_DIR_MOUNT_FLAG) \

=== debian/changelog ===
etcd (3.3.25+dfsg-6) unstable; urgency=medium

  * Team upload.
  * Use packaged library
    + golang-github-grpc-ecosystem-go-grpc-middleware-dev
    + golang-github-soheilhy-cmux-dev
    + golang-github-tmc-grpc-websocket-proxy-dev

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 24 Oct 2020 16:01:47 +0800

etcd (3.3.25+dfsg-5) unstable; urgency=medium

  * Team upload.
  * Upload to unstable
  * Rework goroutine leak patch
  * Disable parallel test to improve stability on slow arch
  * Adapt manpage and default config for 3.3 release

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 10 Oct 2020 03:12:37 +0800

etcd (3.3.25+dfsg-4) experimental; urgency=medium

  * Team upload.
  * Not exit immediately on unsupported arch (Closes: #952536)
  * Add back some old patches to fix flaky tests

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 08 Oct 2020 02:58:49 +0800

etcd (3.3.25+dfsg-3) experimental; urgency=medium

  * Team upload.
  * Backport patch to fix tls test failure

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 08 Oct 2020 00:03:52 +0800

etcd (3.3.25+dfsg-2) experimental; urgency=medium

  * Team upload.
  * Fix tests failed with Ctty not valid in child.
    Address: #971158
  * Rewrite integration and functional tests in autopkgtest
  * Use execute_after_dh_auto_test
  * Update copyright
  * Fix file permission in golang-etcd-server-dev
  * Add Pre-Depends to etcd-server

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 07 Oct 2020 23:23:47 +0800

etcd (3.3.25+dfsg-1) experimental; urgency=medium

  * Team upload.
  * New upstream release 3.3.25
    + CVE-2020-15136 (Closes: #968752)
      Gateway TLS authentication only applies to endpoints detected in DNS SRV
      records
      https://github.com/etcd-io/etcd/security/advisories/GHSA-wr2v-9rpq-c35q
    + CVE-2020-15115 (Closes: #968740)
      No minimum password length
      https://github.com/etcd-io/etcd/security/advisories/GHSA-4993-m7g5-r9hh
    + CVE-2020-15114
      Gateway can include itself as an endpoint resulting in resource
      exhaustion
      https://github.com/etcd-io/etcd/security/advisories/GHSA-2xhq-gv6c-p224
    + CVE-2020-15113
      Directories created via os.MkdirAll are not checked for permissions
      https://github.com/etcd-io/etcd/security/advisories/GHSA-chh6-ppwq-jh92
    + CVE-2020-15112
      An entry with large index causes panic in WAL ReadAll method
      https://github.com/etcd-io/etcd/security/advisories/GHSA-m332-53r6-2w93
    + CVE-2020-15106
      A large slice causes panic in decodeRecord method
      https://github.com/etcd-io/etcd/security/advisories/GHSA-p4g4-wgrh-qrg2
  * Disable some failed tests (Closes: #971158)
  * Bump debhelper compat to 13
  * Add Rules-Requires-Root
  * Bump Standards-Version to 4.5.0 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 06 Oct 2020 22:58:53 +0800

etcd (3.2.26+dfsg-8) unstable; urgency=medium

  * Team upload.
  * debian/patches/embed_tests_fix.patch: New patch, skips
    TestStartEtcdWrongToken test which fails if a etcd server is already
    running independently of the testsuite.

 -- Michael Banck <michael.banck@credativ.de>  Sun, 31 May 2020 10:34:10 +0200

etcd (3.2.26+dfsg-7) unstable; urgency=medium

  * Team upload.
  * debian/rules: Provide an explicit and PHONY build rule, as before
    `debian/rules build' was a no-op which broke autopkgtest-pkg-go
    integration.(Closes: #956424)
  * debian/patches/series: Reactivate and update skip-dev-ptmx-error.patch.
  * debian/patches/e2e_tests_fix.patch,
    debian/patches/functional_tests_fix.patch,
    debian/patches/integration_tests_fix.patch: New patches, fix issues in the
    integration tests.
  * debian/rules: Add new rule autopkgtest which runs the integration tests
    during autopkgtest, as defined by all tests which are not part of
    INTEGRATION_TEST_EXCLUDES.

 -- Michael Banck <michael.banck@credativ.de>  Fri, 29 May 2020 19:01:18 +0200

=== debian/control ===
Source: etcd
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Jelmer Vernooij <jelmer@debian.org>,
           Tim Potter <tpot@hpe.com>,
           Anthony Fok <foka@debian.org>,
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any (>= 2:1.10~),
               golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
               golang-github-coreos-bbolt-dev,
               golang-github-coreos-go-semver-dev (>= 0.2.0~),
               golang-github-coreos-go-systemd-dev,
               golang-github-coreos-pkg-dev (>= 3~),
               golang-github-creack-pty-dev (>= 1.1.11~),
               golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~),
               golang-github-dustin-go-humanize-dev,
               golang-github-gogo-protobuf-dev,
               golang-github-golang-groupcache-dev (>= 0.0~git20160516.0.02826c3~),
               golang-github-google-btree-dev,
               golang-github-google-uuid-dev,
               golang-github-gorilla-websocket-dev,
               golang-github-grpc-ecosystem-go-grpc-middleware-dev,
               golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
               golang-github-grpc-ecosystem-grpc-gateway-dev (>= 1.2.0~),
               golang-github-jonboulle-clockwork-dev,
               golang-github-json-iterator-go-dev,
               golang-github-modern-go-reflect2-dev,
               golang-github-olekukonko-tablewriter-dev (>= 0.0~git20170122.0.a0225b3~),
               golang-github-prometheus-client-golang-dev (>= 1.0.0~),
               golang-github-prometheus-client-model-dev,
               golang-github-soheilhy-cmux-dev,
               golang-github-spf13-cobra-dev,
               golang-github-spf13-pflag-dev,
               golang-github-tmc-grpc-websocket-proxy-dev,
               golang-github-urfave-cli-dev,
               golang-github-xiang90-probing-dev (>= 0.0.1~),
               golang-go.uber-zap-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-time-dev,
               golang-google-genproto-dev,
               golang-google-grpc-dev,
               golang-gopkg-cheggaaa-pb.v1-dev,
               golang-gopkg-yaml.v2-dev,
               golang-goprotobuf-dev,
               golang-k8s-sigs-yaml-dev,
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/etcd
Vcs-Git: https://salsa.debian.org/go-team/packages/etcd.git
Homepage: https://etcd.io
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/coreos/etcd

Package: etcd
Architecture: all
Section: oldlibs
Depends: etcd-client,
         etcd-server,
         ${misc:Depends},
Description: Transitional package for etcd-client and etcd-server
 This is a transitional package to ease upgrades for splitting the
 etcd package into a separate client and server piece. It can be
 safely removed.

Package: etcd-server
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         lsb-base,
         pipexec,
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: etcd-client,
Built-Using: ${misc:Built-Using},
Description: highly-available key value store -- daemon
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the server binaries.

Package: etcd-client
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Built-Using: ${misc:Built-Using},
Description: highly-available key value store -- client
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the client binaries.

Package: golang-etcd-server-dev
Architecture: all
Depends: golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
         golang-github-coreos-bbolt-dev,
         golang-github-coreos-go-semver-dev (>= 0.2.0~),
         golang-github-coreos-go-systemd-dev,
         golang-github-coreos-pkg-dev (>= 3~),
         golang-github-creack-pty-dev (>= 1.1.11~),
         golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~),
         golang-github-dustin-go-humanize-dev,
         golang-github-gogo-protobuf-dev,
         golang-github-golang-groupcache-dev (>= 0.0~git20160516.0.02826c3~),
         golang-github-google-btree-dev,
         golang-github-google-uuid-dev,
         golang-github-gorilla-websocket-dev,
         golang-github-grpc-ecosystem-go-grpc-middleware-dev,
         golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
         golang-github-grpc-ecosystem-grpc-gateway-dev (>= 1.2.0~),
         golang-github-jonboulle-clockwork-dev,
         golang-github-json-iterator-go-dev,
         golang-github-modern-go-reflect2-dev,
         golang-github-olekukonko-tablewriter-dev (>= 0.0~git20170122.0.a0225b3~),
         golang-github-prometheus-client-golang-dev (>= 1.0.0~),
         golang-github-prometheus-client-model-dev,
         golang-github-soheilhy-cmux-dev,
         golang-github-spf13-cobra-dev,
         golang-github-spf13-pflag-dev,
         golang-github-tmc-grpc-websocket-proxy-dev,
         golang-github-urfave-cli-dev,
         golang-github-xiang90-probing-dev (>= 0.0.1~),
         golang-go.uber-zap-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-time-dev,
         golang-google-genproto-dev,
         golang-google-grpc-dev,
         golang-gopkg-cheggaaa-pb.v1-dev,
         golang-gopkg-yaml.v2-dev,
         golang-goprotobuf-dev,
         golang-k8s-sigs-yaml-dev,
         ${misc:Depends},
Provides: golang-github-coreos-etcd-dev,
Description: highly-available key value store -- source
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the source.

=== debian/tests/control ===
Test-Command: /usr/bin/dh_golang_autopkgtest
Depends: @,
         @builddeps@,
Restrictions: allow-stderr
Features: test-name=dh-golang-autopkgtest

Tests: integration
Depends: curl,
         etcd-client,
         etcd-server,
         @builddeps@,
Restrictions: allow-stderr, needs-root, breaks-testbed, isolation-container, skippable

Tests: functional
Depends: netcat-openbsd,
         @builddeps@,
Restrictions: allow-stderr, isolation-container, skippable

=== debian/watch ===
version=3

opts=\
repacksuffix=+dfsg,\
dversionmangle=s{\+dfsg\d*}{},\
 https://github.com/etcd-io/etcd/releases \
 .*/archive/v?(\d[-\d\.]+)\.tar\.gz

## etcd 3.4.23

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 build:
 	GO_BUILD_FLAGS="-v" ./build
 	./bin/etcd --version
-	ETCDCTL_API=3 ./bin/etcdctl version
+	./bin/etcdctl version
 
 clean:
 	rm -f ./codecov
@@ -30,6 +30,7 @@
 	rm -rf ./gopath.proto
 	rm -rf ./release
 	rm -f ./snapshot/localhost:*
+	rm -f ./tools/etcd-dump-metrics/localhost:*
 	rm -f ./integration/127.0.0.1:* ./integration/localhost:*
 	rm -f ./clientv3/integration/127.0.0.1:* ./clientv3/integration/localhost:*
 	rm -f ./clientv3/ordering/127.0.0.1:* ./clientv3/ordering/localhost:*
@@ -50,7 +51,7 @@
 
 
 
-GO_VERSION ?= 1.12.9
+GO_VERSION ?= 1.12.17
 ETCD_VERSION ?= $(shell git rev-parse --short HEAD || echo "GitNotFound")
 
 TEST_SUFFIX = $(shell date +%s | base64 | head -c 15)
@@ -64,11 +65,11 @@
 
 
 # Example:
-#   GO_VERSION=1.12.9 make build-docker-test
+#   GO_VERSION=1.12.17 make build-docker-test
 #   make build-docker-test
 #
 #   gcloud docker -- login -u _json_key -p "$(cat /etc/gcp-key-etcd-development.json)" https://gcr.io
-#   GO_VERSION=1.12.9 make push-docker-test
+#   GO_VERSION=1.12.17 make push-docker-test
 #   make push-docker-test
 #
 #   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com
@@ -78,17 +79,17 @@
 	$(info GO_VERSION: $(GO_VERSION))
 	@sed -i.bak 's|REPLACE_ME_GO_VERSION|$(GO_VERSION)|g' ./tests/Dockerfile
 	docker build \
-	  --tag gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3 \
+	  --tag gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
 	  --file ./tests/Dockerfile .
 	@mv ./tests/Dockerfile.bak ./tests/Dockerfile
 
 push-docker-test:
 	$(info GO_VERSION: $(GO_VERSION))
-	gcloud docker -- push gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3
+	gcloud docker -- push gcr.io/etcd-development/etcd-test:go$(GO_VERSION)
 
 pull-docker-test:
 	$(info GO_VERSION: $(GO_VERSION))
-	docker pull gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3
+	docker pull gcr.io/etcd-development/etcd-test:go$(GO_VERSION)
 
 
 
@@ -101,8 +102,8 @@
 	$(info GO_VERSION: $(GO_VERSION))
 	docker run \
 	  --rm \
-	  --mount type=bind,source=`pwd`,destination=/go/src/github.com/coreos/etcd \
-	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3 \
+	  --mount type=bind,source=`pwd`,destination=/go/src/go.etcd.io/etcd \
+	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
 	  /bin/bash -c "GO_BUILD_FLAGS=-v GOOS=linux GOARCH=amd64 ./build && ./bin/etcd --version"
 
 compile-setup-gopath-with-docker-test:
@@ -110,7 +111,7 @@
 	docker run \
 	  --rm \
 	  --mount type=bind,source=`pwd`,destination=/etcd \
-	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3 \
+	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
 	  /bin/bash -c "cd /etcd && ETCD_SETUP_GOPATH=1 GO_BUILD_FLAGS=-v GOOS=linux GOARCH=amd64 ./build && ./bin/etcd --version && rm -rf ./gopath"
 
 
@@ -157,8 +158,8 @@
 	docker run \
 	  --rm \
 	  $(TMP_DIR_MOUNT_FLAG) \
-	  --mount type=bind,source=`pwd`,destination=/go/src/github.com/coreos/etcd \
-	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3 \
+	  --mount type=bind,source=`pwd`,destination=/go/src/go.etcd.io/etcd \
+	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
 	  /bin/bash -c "$(TEST_OPTS) ./test 2>&1 | tee test-$(TEST_SUFFIX).log"
 	! egrep "(--- FAIL:|DATA RACE|panic: test timed out|appears to have leaked)" -B50 -A10 test-$(TEST_SUFFIX).log
 
@@ -171,8 +172,8 @@
 	docker run \
 	  --rm \
 	  $(TMP_DIR_MOUNT_FLAG) \
-	  --mount type=bind,source=`pwd`,destination=/go/src/github.com/coreos/etcd \
-	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION)-release-3.3 \
+	  --mount type=bind,source=`pwd`,destination=/go/src/go.etcd.io/etcd \
+	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
 	  /bin/bash -c "COVERDIR=covdir PASSES='build build_cov cov' ./test 2>&1 | tee docker-test-coverage-$(TEST_SUFFIX).log && /codecov -t 6040de41-c073-4d6f-bbf8-d89256ef31e1"
 	! egrep "(--- FAIL:|DATA RACE|panic: test timed out|appears to have leaked)" -B50 -A10 docker-test-coverage-$(TEST_SUFFIX).log
 
@@ -196,7 +197,7 @@
 	docker run \
 	  --rm \
 	  gcr.io/etcd-development/etcd:$(ETCD_VERSION) \
-	  /bin/sh -c "/usr/local/bin/etcd --version && ETCDCTL_API=3 /usr/local/bin/etcdctl version"
+	  /bin/sh -c "/usr/local/bin/etcd --version && /usr/local/bin/etcdctl version"
 
 push-docker-release-master:
 	$(info ETCD_VERSION: $(ETCD_VERSION))
@@ -355,3 +356,4 @@
 	  --tty \
 	  --dns 127.0.0.1 \
 	  $(TMP_DIR_MOUNT_FLAG) \
+	  --mount type=bind,source=`pwd`/bin,destination=/etcd \

=== debian/changelog ===
etcd (3.4.23-4ubuntu2) mantic; urgency=medium

  * No-change rebuild with Go 1.21.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 24 Aug 2023 17:13:53 +1200

etcd (3.4.23-4ubuntu1) mantic; urgency=medium

  * SECURITY UPDATE: debug leaks credentials
    - debian/patches/CVE-2021-28235.patch: blanks out password
    - CVE-2021-28235

 -- Mark Esler <mark.esler@canonical.com>  Thu, 22 Jun 2023 18:51:27 -0500

etcd (3.4.23-4) unstable; urgency=medium

  * Team upload.
  * Add patch to skip flaky TestReadWriteTimeout
  * Add vip-manager << 1.0.2-5~ to Breaks

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 09 Jan 2023 19:29:55 +0800

etcd (3.4.23-3) unstable; urgency=medium

  * Team upload.
  * Fix TestCorruptedBackupFileCheck on big-endian

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 04 Jan 2023 19:09:06 +0800

etcd (3.4.23-2) unstable; urgency=medium

  * Team upload.
  * Drop etcd transitional package
  * Update Standards-Version to 4.6.2 (no changes)
  * Add github.com/coreos/etcd to Go-Import-Path as well
  * Remove all options from default.
    Duplicated with upstream documentation
  * Rewrite sysv init with init-d-script
  * Update manpages

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 02 Jan 2023 21:49:43 +0800

etcd (3.4.23-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 3.4.23
    + Address CVE-2018-1098 CVE-2018-1099:
      Mitigate CSRF and DNS Rebinding attacks.
      Added --host-whitelist option.
  * Refresh patches. Drop:
    - 0005-go1.14-cipher.patch
    - 0007-switch-to-creack-pty.patch
    - 0008-use-TLS.Config.MaxVersion-to-TLS-1.2.patch
  * Change Go-Import-Path to go.etcd.io/etcd
  * Add patch for datadriven 1.0.2
  * Exclude tools when building
  * Fix package name in integration test
  * Install symlink for old path github.com/coreos/etcd
  * Add Breaks in golang-etcd-server-dev package
    + golang-github-docker-docker-dev
    + nextcloud-spreed-signaling

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 01 Jan 2023 23:54:56 +0800

etcd (3.3.25+dfsg-8) unstable; urgency=medium

  * Team upload.

  [ Sam Q ]
  * Fix for correcting error searching new upstream

  [ Shengjing Zhu ]
  * Backport grpc 1.32 support

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 29 Oct 2022 20:29:46 +0800

etcd (3.3.25+dfsg-7) unstable; urgency=medium

  * Team upload.

  [ Shengjing Zhu ]
  * Switch autopkgtest to the new Architecture: field

  [ Reinhard Tartler ]
  * Avoid postinst crashes, Closes: #889714

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 24 Feb 2022 22:18:53 -0500

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: etcd
-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Jelmer Vernooij <jelmer@debian.org>,
            Tim Potter <tpot@hpe.com>,
            Anthony Fok <foka@debian.org>,
@@ -9,18 +10,18 @@
                dh-golang,
                golang-any (>= 2:1.10~),
                golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
+               golang-github-cockroachdb-datadriven-dev,
                golang-github-coreos-bbolt-dev,
                golang-github-coreos-go-semver-dev (>= 0.2.0~),
                golang-github-coreos-go-systemd-dev,
                golang-github-coreos-pkg-dev (>= 3~),
                golang-github-creack-pty-dev (>= 1.1.11~),
-               golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~),
                golang-github-dustin-go-humanize-dev,
                golang-github-gogo-protobuf-dev,
                golang-github-golang-groupcache-dev (>= 0.0~git20160516.0.02826c3~),
+               golang-github-golang-jwt-jwt-dev,
                golang-github-google-btree-dev,
                golang-github-google-uuid-dev,
-               golang-github-gorilla-websocket-dev,
                golang-github-grpc-ecosystem-go-grpc-middleware-dev,
                golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
                golang-github-grpc-ecosystem-grpc-gateway-dev (>= 1.2.0~),
@@ -33,6 +34,7 @@
                golang-github-soheilhy-cmux-dev,
                golang-github-spf13-cobra-dev,
                golang-github-spf13-pflag-dev,
+               golang-github-stretchr-testify-dev,
                golang-github-tmc-grpc-websocket-proxy-dev,
                golang-github-urfave-cli-dev,
                golang-github-xiang90-probing-dev (>= 0.0.1~),
@@ -41,36 +43,24 @@
                golang-golang-x-net-dev,
                golang-golang-x-sys-dev,
                golang-golang-x-time-dev,
-               golang-google-genproto-dev,
+               golang-golang-x-tools,
                golang-google-grpc-dev,
                golang-gopkg-cheggaaa-pb.v1-dev,
                golang-gopkg-yaml.v2-dev,
                golang-goprotobuf-dev,
                golang-k8s-sigs-yaml-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/etcd
 Vcs-Git: https://salsa.debian.org/go-team/packages/etcd.git
 Homepage: https://etcd.io
 Rules-Requires-Root: no
-XS-Go-Import-Path: github.com/coreos/etcd
-
-Package: etcd
-Architecture: all
-Section: oldlibs
-Depends: etcd-client,
-         etcd-server,
-         ${misc:Depends},
-Description: Transitional package for etcd-client and etcd-server
- This is a transitional package to ease upgrades for splitting the
- etcd package into a separate client and server piece. It can be
- safely removed.
+XS-Go-Import-Path: go.etcd.io/etcd,
+                   github.com/coreos/etcd
 
 Package: etcd-server
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends},
 Depends: adduser,
-         lsb-base,
-         pipexec,
          ${misc:Depends},
          ${shlibs:Depends},
 Suggests: etcd-client,
@@ -111,18 +101,18 @@
 Package: golang-etcd-server-dev
 Architecture: all
 Depends: golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
+         golang-github-cockroachdb-datadriven-dev,
          golang-github-coreos-bbolt-dev,
          golang-github-coreos-go-semver-dev (>= 0.2.0~),
          golang-github-coreos-go-systemd-dev,
          golang-github-coreos-pkg-dev (>= 3~),
          golang-github-creack-pty-dev (>= 1.1.11~),
-         golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~),
          golang-github-dustin-go-humanize-dev,
          golang-github-gogo-protobuf-dev,
          golang-github-golang-groupcache-dev (>= 0.0~git20160516.0.02826c3~),
+         golang-github-golang-jwt-jwt-dev,
          golang-github-google-btree-dev,
          golang-github-google-uuid-dev,
-         golang-github-gorilla-websocket-dev,
          golang-github-grpc-ecosystem-go-grpc-middleware-dev,
          golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
          golang-github-grpc-ecosystem-grpc-gateway-dev (>= 1.2.0~),
@@ -143,7 +133,6 @@
          golang-golang-x-net-dev,
          golang-golang-x-sys-dev,
          golang-golang-x-time-dev,
-         golang-google-genproto-dev,
          golang-google-grpc-dev,
          golang-gopkg-cheggaaa-pb.v1-dev,
          golang-gopkg-yaml.v2-dev,
@@ -151,6 +140,9 @@
          golang-k8s-sigs-yaml-dev,
          ${misc:Depends},
 Provides: golang-github-coreos-etcd-dev,
+Breaks: golang-github-docker-docker-dev (<< 20.10.21+dfsg1-2~),
+        nextcloud-spreed-signaling (<< 0.4.1-3~),
+        vip-manager (<<1.0.2-5~),
 Description: highly-available key value store -- source
  A highly-available key value store for shared configuration and service
  discovery. etcd is inspired by zookeeper and doozer, with a focus on:

## etcd 3.4.30

=== Makefile ===
--- 
+++ 
@@ -51,7 +51,7 @@
 
 
 
-GO_VERSION ?= 1.12.17
+GO_VERSION ?= 1.20.13
 ETCD_VERSION ?= $(shell git rev-parse --short HEAD || echo "GitNotFound")
 
 TEST_SUFFIX = $(shell date +%s | base64 | head -c 15)
@@ -147,6 +147,22 @@
 	$(info log-file: test-$(TEST_SUFFIX).log)
 	$(TEST_OPTS) ./test 2>&1 | tee test-$(TEST_SUFFIX).log
 	! egrep "(--- FAIL:|DATA RACE|panic: test timed out|appears to have leaked)" -B50 -A10 test-$(TEST_SUFFIX).log
+
+.PHONY: test-unit
+test-unit:
+	PASSES="unit" ./test $(GO_TEST_FLAGS)
+
+.PHONY: test-integration
+test-integration:
+	PASSES="integration" ./test $(GO_TEST_FLAGS)
+
+.PHONY: test-e2e
+test-e2e:
+	PASSES="build e2e" ./test $(GO_TEST_FLAGS)
+
+.PHONY: test-e2e-release
+test-e2e-release:
+	PASSES="build release e2e" ./test $(GO_TEST_FLAGS)
 
 docker-test:
 	$(info GO_VERSION: $(GO_VERSION))
@@ -347,13 +363,3 @@
 	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
 	  /bin/bash -c "cd /etcd && /certs-gateway/run.sh && rm -rf m*.etcd"
 
-docker-dns-test-certs-wildcard-run:
-	$(info GO_VERSION: $(GO_VERSION))
-	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
-	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
-	docker run \
-	  --rm \
-	  --tty \
-	  --dns 127.0.0.1 \
-	  $(TMP_DIR_MOUNT_FLAG) \
-	  --mount type=bind,source=`pwd`/bin,destination=/etcd \

=== debian/changelog ===
etcd (3.4.30-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:56:40 +0000

etcd (3.4.30-1) unstable; urgency=medium

  * Team upload
  * New upstream version 3.4.30
    + CVE-2021-28235 (fixed in 3.4.25): Clearing password after authenticating
      the user.
    + CVE-2023-32082 (fixed in 3.4.26): LeaseTimeToLive API may return keys to
      clients which have no read permission on the keys

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 28 Feb 2024 17:43:49 +0800

etcd (3.4.23-6) unstable; urgency=medium

  * Team upload
  * Add a patch to skip flaky test that failed on 3/10 buildds

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 17 Feb 2024 00:31:39 +0000

etcd (3.4.23-5) unstable; urgency=medium

  * Team upload
  * d/control:
    - Replace transitional golang-goprotobuf-dev package
    - Allow golang-github-golang-protobuf-1-5-dev as optional Depends
  * Add a patch to skip tests that fail in some environments

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 16 Feb 2024 22:07:53 +0000

=== debian/control ===
--- 
+++ 
@@ -47,7 +47,7 @@
                golang-google-grpc-dev,
                golang-gopkg-cheggaaa-pb.v1-dev,
                golang-gopkg-yaml.v2-dev,
-               golang-goprotobuf-dev,
+               golang-github-golang-protobuf-1-3-dev,
                golang-k8s-sigs-yaml-dev,
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/etcd
@@ -136,7 +136,7 @@
          golang-google-grpc-dev,
          golang-gopkg-cheggaaa-pb.v1-dev,
          golang-gopkg-yaml.v2-dev,
-         golang-goprotobuf-dev,
+         golang-github-golang-protobuf-1-3-dev | golang-github-golang-protobuf-1-5-dev,
          golang-k8s-sigs-yaml-dev,
          ${misc:Depends},
 Provides: golang-github-coreos-etcd-dev,

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_GO_GENERATE := 1
export DH_GOLANG_EXCLUDES := tools
export DH_GOLANG_INSTALL_EXTRA := $(shell find . -name fixtures-expired) \
                                  $(shell find . -name fixtures)

# The ignored pkgs are aligned with upstream ./test file,
# see variables IGNORE_PKGS and INTEGRATION_PKGS in ./test
export TEST_EXCLUDES := cmd/ etcdserverpb rafttest gopath.proto v3lockpb v3electionpb \
                        integration e2e contrib functional

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_test:
	DH_GOLANG_EXCLUDES="$(DH_GOLANG_EXCLUDES) $(TEST_EXCLUDES)" dh_auto_test -O--no-parallel -- -run=Test

execute_after_dh_auto_test:
	find _build -type s -delete

# Handle package name (etcd-server) != service name (etcd)
override_dh_installinit:
	dh_installinit -p etcd-server --name=etcd
override_dh_installsystemd:
	dh_installsystemd -p etcd-server --name=etcd

# autopktest-pkg-go integration runs "debian/rules build", which is a no-op due
# to a script "build" present in the upstream source. This (PHONY) target
# overrides this.
build:
	dh build --buildsystem=golang --with=golang --builddirectory=_build

.PHONY: build

## etcd 3.5.13

=== debian/changelog ===
etcd (3.5.13-1) unstable; urgency=medium

  * Update to new etcd version 3.5.13

 -- root <root@4783d7cbe4f7>  Fri, 17 May 2024 07:19:43 +0000

etcd (3.5.13-1) unstable; urgency=low
  * Initial Release.
 -- EvgeniyPatlan <evgeniy.patlan@percona.com> Fri, 17 May 2024 07:19:43 +0000
